(**************************************************************)
(*   The Strong Completeness of Partial Monoidal Boolean BI   *)
(*   Copyright Dominique Larchey-Wendling [*]                 *)
(*                                                            *)
(*                             [*] Affiliation LORIA -- CNRS  *)
(**************************************************************)
(*      This file is distributed under the terms of the       *)
(*         CeCILL v2 FREE SOFTWARE LICENSE AGREEMENT          *)
(**************************************************************)

Proposition replace_eq (G H : Prop) : G = H -> G -> H.
Proof. intros H1 H2. rewrite <- H1; auto. Qed.

Ltac replace_with K := apply replace_eq with (2 := K); repeat (f_equal; auto).

Section Replace_example.

  Variable P : nat -> Prop.

  Let test x y : x = y -> P x -> P y.
  Proof. intros ? H2; replace_with H2. Qed.

End Replace_example.

